#include "..\config.h"

#ifdef IncludeRebuild

#ifdef gccruntime
#include <stdio.h>
#endif

namespace bnf {

#include "main.h"

#define debug bnfdebugsplit

extern char* GrammarTree;
extern char* pInitSymbol;

char* SourceBuffer;
unsigned long SourceFileSize;

int Space = 0;

char StrOutBuffer[65];

extern "C" char* pTree;
char* pTree;
int nTreeSize = 0;
extern "C" int nTreeSizeMax;
int nTreeSizeMax = 0;

char AddChar[2] = " ";

int AddInt;

void AddTree(char* val, int vallen = 0)
{
	char* pOldTree;

	if (vallen == 0)
	{
		vallen = strlen(val);
	}

	if (nTreeSize + vallen >= nTreeSizeMax)
	{
		nTreeSizeMax += SmallBufferLen;
		pOldTree = pTree;
		if ((pTree = (char*) mallocl(nTreeSizeMax, "AddTree-pTree")) == 0)
		{
			printf("Memmory Allocation Error\n");
			exit(1);
		}
		pTree[0] = 0;
		if (nTreeSize)
		{
			CopyMemory(pTree, pOldTree, nTreeSize + 1);
		}
		if (pOldTree)
		{
			freel(pOldTree);
		}
	}

	CopyMemory(pTree + nTreeSize, val, vallen);
	nTreeSize += vallen;
}

void TreeSub(int SymbolID)
{
	AddChar[0] = 1;
	AddTree(AddChar, 1);
	AddInt = (int) SymbolPointer[SymbolID];
	AddTree((char*) &AddInt, sizeof(int));
}

void TreeReturn()
{
	AddChar[0] = 0;
	AddTree(AddChar, 1);
}

template <class T>int FindMemory(T* start, T val)
{
	int i = 1;
	while (*start)
	{
		if (*start++ == val)
		{
			return(i);
		}
		i++;
	}
	return(0);
}

void PrintFoundLine(char* SymbolStartPos, char* SymbolEndPos)
{
	char* pTemp;
	char* oBuffer;

	while (*SymbolEndPos == 13 || *SymbolEndPos == 10)
	{
		SymbolEndPos--;
	}
	
	for (pTemp = SymbolEndPos;pTemp >= SymbolStartPos;pTemp--)
	{
		if (*pTemp == 10 || *pTemp == 13)
		{
			break;
		}
	}

	if (!(oBuffer = (char*) mallocl(SymbolEndPos - pTemp + 1, "PrintFoundLine-oBuffer")))
	{
		printf("Memory Allocation Error\n");
		getchar();
		exit(1);
	}

	CopyMemory(oBuffer, pTemp + 1, SymbolEndPos - pTemp);
	oBuffer[SymbolEndPos - pTemp - 1] = 0;
	printf("\"%s\"", oBuffer);
	freel(oBuffer);
}

char* DoRule(char* CodePos, char* Symbol, int tCompressed, char* tSymbolName = NULL, bool bnot = false)
{
	char *pGrammar = Symbol, *pCode = CodePos, *pRet, *pTemp, *pTempAll = CodePos;
	char *pNot, *pNotTemp;
	int Compressed;

	char* SymbolName;
	int SymbolID;

	char* SeperatorStartPos = CodePos;
	char* SymbolStartPos = CodePos;

	int i;
	int CheckForComment;
	char* pComment;
	int CheckForSeperator;

	bool SyntaxCorrect;
	bool DontSkip;

	int nTreeInitSize = nTreeSize;
	int nTreeNotTemp;
	
	char prSpace[16];

	Space++;
	sprintf(prSpace, "%%%ds", Space * 2);

	if (bnot)
	{
		Compressed = tCompressed;
		if (!(SymbolName = (char*) mallocl(strlen(tSymbolName) + 5, "DoRule-SymbolName")))
		{
			printf("Memory Allocation Error\n");
			getchar();
			exit(1);
		}
		sprintf(SymbolName, "%s NOT", tSymbolName);
	}
	else
	{
		Compressed = *((int*) pGrammar) | tCompressed;
		pGrammar += sizeof(int);
		SymbolID = *((int*) pGrammar);
		pGrammar += sizeof(int);

		if (!(SymbolName = (char*) mallocl(strlen(pGrammar) + 1, "DoRule-SymbolName2")))
		{
			printf("Memory Allocation Error\n");
			return(0);
		}
		strcpy(SymbolName, pGrammar);
		pGrammar += strlen(pGrammar) + 1;
	}

	if (debug && !tCompressed)
	{
		printf(prSpace, "");
		printf("%10d %s\n", ((int) (pCode - SourceBuffer)), SymbolName);
	}

	pNot = pCode;

	if (!tCompressed)
	{
		TreeSub(SymbolID);
	}

	while (*pGrammar)
	{
		if (pCode >= SourceBuffer + SourceFileSize && pCode == 0)
		{
			return(0);
		}
		SyntaxCorrect = false;
		if (Compressed == 0)
		{
			CheckForComment = 1;

			while (CheckForComment)
			{
				CheckForComment = 0;

				do
				{
					CheckForSeperator = 0;
					for (i = 0;i < nSeperatorCount;i++)
					{
						if (*pCode == lpSeperatorBytes[i])
						{
							pCode++;
							CheckForSeperator = 1;
							break;
						}
					}
				} while (CheckForSeperator);

				pComment = lpComments;

				while (*pComment)
				{
					if (strncmp(pCode, pComment, strlen(pComment)) == 0)
					{
						pComment += strlen(pComment) + 1;
						CheckForComment = 1;

						while (strncmp(pCode++ - strlen(pComment) + 1, pComment, strlen(pComment)) != 0) {}
					}
					else
					{
						pComment += strlen(pComment) + 1;
					}
					pComment += strlen(pComment) + 1;
				}
			}
		}

		if (*((int*) pGrammar) == gLink)
		{
			if ((char*) *((int*) (pGrammar + sizeof(int))))
			{
				pRet = DoRule(pCode, (char*) *((int*) (pGrammar + sizeof(int))), Compressed);
				SyntaxCorrect = (pRet > 0);
				if (pRet) {pCode = pRet;}
			}
			else
			{
				if (*pCode == '_')
				{
					AddTree(" ", 1);
				}
				else
				{
					AddTree(pCode, 1);
				}
				pCode++;
				SyntaxCorrect = true;
			}
			pGrammar += 2 * sizeof(int);
		}
		else if (*((int*) pGrammar) == gGroup)
		{
			pRet = DoRule(pCode, (char*) *((int*) (pGrammar + sizeof(int))), Compressed);
			if (pRet) {pCode = pRet;}

			SyntaxCorrect = (pRet > 0);

			pGrammar += 2 * sizeof(int);
		}
		else if (*((int*) pGrammar) == gOpt)
		{
			pRet = DoRule(pCode, (char*) *((int*) (pGrammar + sizeof(int))), Compressed);
			if (pRet)
			{
				pCode = pRet;
			}
			pGrammar += 2 * sizeof(int);
			SyntaxCorrect = true;
		}
		else if (*((int*) pGrammar) == gRep)
		{
			do
			{
				pTemp = pCode;
				pRet = DoRule(pCode, (char*) *((int*) (pGrammar + sizeof(int))), Compressed);
				if (pRet) {pCode = pRet;}
			} while (pRet && pRet != pTemp);
			pGrammar += 2 * sizeof(int);
			SyntaxCorrect = true;
		}
		else if (*((int*) pGrammar) == gString)
		{
			SyntaxCorrect = true;
			i = min(*((int*) (pGrammar + sizeof(int))), 64);
			CopyMemory(StrOutBuffer, (void*) (pGrammar + 2 * sizeof(int)), i);
			StrOutBuffer[i] = 0;
			
			for (i = 0;i < (*((int*) (pGrammar + sizeof(int))));i++)
			{
				if (ucase(*(pGrammar + 2 * sizeof(int) + i)) != ucase(*(pCode + i)))
				{
					SyntaxCorrect = false;
					break;
				}
			}
			if (SyntaxCorrect)
			{
				pCode += *((int*) (pGrammar + sizeof(int)));
				if (debug && !tCompressed)
				{
					printf(prSpace, "");
					printf("%5s%10d FOUND \"%s\"\n", "", (pCode - SourceBuffer), StrOutBuffer);
				}
				AddTree(StrOutBuffer);
			}
			pGrammar += *((int*) (pGrammar + sizeof(int))) + 2 * sizeof(int);
		}
		else if (*((int*) pGrammar) == gNot)
		{
			pGrammar += sizeof(int);

			pNotTemp = pCode;
			pCode = pNot;

			nTreeNotTemp = nTreeSize;
			pTemp = DoRule(pCode, pGrammar, Compressed, SymbolName, true);
			nTreeSize = nTreeNotTemp;
			pTree[nTreeSize] = 0;
			SyntaxCorrect = (pTemp != pNotTemp);
			pGrammar = SkipRule(pGrammar);

			if (SyntaxCorrect) {pCode = pNotTemp;}
		}
		else if (*((int*) pGrammar) == gSep)
		{
			pGrammar += sizeof(int);
			pNot = pCode;
			SyntaxCorrect = true;
			SeperatorStartPos = pCode;
		}
		else if (*((int*) pGrammar) == gOr)
		{
			pGrammar += sizeof(int);
			if (!DontSkip)
			{
				pGrammar = SkipRule(pGrammar);
			}
			SyntaxCorrect = true;
		}
		else if (*((int*) pGrammar) == gEnd)
		{
			goto EndFound;
		}
		else
		{
			printf("Internal Error\n");
			getchar();
			exit(1);
		}
		DontSkip = false;
		if (!SyntaxCorrect)
		{
			if (!(*((int*) pGrammar) == gOr))
			{
				if (debug && !tCompressed)
				{
					printf(prSpace, "");
					printf("%10d FAILED %s\n", (int) (pCode - SourceBuffer), SymbolName);
				}

				nTreeSize = nTreeInitSize;
				pTree[nTreeSize] = 0;

				Space--;
				freel(SymbolName);
				return(0);
			}
			DontSkip = true;
		}
	}
EndFound:
	if (debug && !tCompressed)
	{
		printf(prSpace, "");
		if (pCode != pTempAll)
		{
			printf("%10d FOUND %s:     ", (int) (pCode - SourceBuffer), SymbolName);
			PrintFoundLine(SymbolStartPos, pCode);
			printf("\n");
		}
		else
		{
			printf("%10d SKIP  %s\n", (int) (pCode - SourceBuffer), SymbolName);
		}
	}

	if (pCode != pTempAll)
	{
		if (!tCompressed)
		{
			TreeReturn();
		}
	}
	else
	{
		nTreeSize = nTreeInitSize;
		pTree[nTreeSize] = 0;
	}

	Space--;
	freel(SymbolName);
	return(pCode);
}

int SplitFile(char* FileName)
{
	//HANDLE hFile;
	int i;
	//DWORD r1, r2, r3;

	char* NewFileName;

	printf("Opening Source File\n");
	if (!(SourceFileSize = ReadFileToBuffer(FileName, &SourceBuffer)))
	{
		printf("Error loading Source File\n");
		return(1);
	}

	printf("Splitting Source file\n");

	if (DoRule(SourceBuffer, pInitSymbol, 0) != SourceBuffer + SourceFileSize)
	{
		printf("Content does not match Grammar\n");
		return(1);
	}
	printf("Content Matches Grammar\n");

	if ((NewFileName = (char*) mallocl(strlen(FileName) + 5, "SplitFile-NewFileName")) == 0)
	{
		printf("Memory Allocation Error\n");
		return(1);
	}
	strcpy(NewFileName, FileName);
	for (i = strlen(NewFileName) - 1;i > 0;i--)
	{
		if (NewFileName[i] == '.')
		{
			break;
		}
	}
	if (i == 0)
	{
		i = strlen(NewFileName);
	}
	NewFileName[i] = 0;
	strcat(NewFileName, ".kfa");

	printf("Writing Output to %s\n", NewFileName);
	/*hFile = CreateFile(NewFileName, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile == INVALID_HANDLE_VALUE)
	{
		printf("Cannot create Output File\n");
		return(1);
	}
	WriteFile(hFile, &SymbolNameSize, sizeof(int), &r1, NULL);
	WriteFile(hFile, SymbolNames, SymbolNameSize, &r2, NULL);
	WriteFile(hFile, pTree, nTreeSize, &r3, NULL);
	if ((signed) r3 != nTreeSize || (signed) r2 != SymbolNameSize || r1 != sizeof(int))
	{
		printf("Error writing Output File\n");
		return(1);
	}
	CloseHandle(hFile);*/

	freel(NewFileName);

	nTreeSize = 0;
	
	if (DebugOutput)
	{
		printf("Freeing Memory\n");
	}
	freel(SourceBuffer);

	if (DebugOutput)
	{
		printf("Finished\n");
	}
	return(0);
}

int Split(char* FileName)
{
	return(SplitFile(FileName));
}

}

#endif