int GetValNumber(char** Vals, char* String, int Number, bool Force = true)
{
	int i;
	for (i = 0;i < Number;i++)
	{
		if (strcmp(Vals[i], String) == 0)
		{
			return(i);
		}
	}
	if (Force)
	{
		printf("Value not found: %s\n", String);
		quitprog();
	}
	return(-1);
}

char *buffer;
int buffersize;

int CountSetLines(FILE* fFile)
{
	int Number = 0;
	fseek(fFile, 0, SEEK_SET);
	fgets(buffer, buffersize, fFile);
	fgets(buffer, buffersize, fFile);
	while (!feof(fFile))
	{
		if (fgets(buffer, buffersize, fFile) == NULL)
		{
			break;
		}
		if (buffer[0] != 10 && buffer[0] != 13)
		{
			Number++;
		}
	}
	fseek(fFile, 0, SEEK_SET);
	fgets(buffer, buffersize, fFile);
	fgets(buffer, buffersize, fFile);

	return(Number);
}

void ProcessLine(FILE *fFile, void (*ProcessFunction)(char* Vals[MaxArgs], void* TargetStruct, int Number, bool header), void* TargetStruct, bool header)
{
	char* Vals[MaxArgs];
	bool nextval = false;
	unsigned int i, j, k;

	do
	{
		fgets(buffer, buffersize, fFile);
	} while (buffer[0] == 10 || buffer[0] == 13);
	Vals[0] = &buffer[0];
	j = 1;
	k = strlen(buffer);
	for (i = 0;i < k;i++)
	{
		if (buffer[i] == 10 || buffer[i] == 13)
		{
			buffer[i] = 0;
		}
		else if (buffer[i] == 32 || buffer[i] == 9)
		{
			nextval = true;
			buffer[i] = 0;
		}
		else if (nextval)
		{
			nextval = false;
			Vals[j] = &buffer[i];
			j++;
		}
	}
	ProcessFunction(&Vals[0], TargetStruct, j, header);
}

template <class T> int SourceInit(char* FileName, T** Source, int* SourceCount, void (*ProcessFunction)(char** Vals, void* TargetStruct, int Number, bool header), int AddMem = 0, bool NoAlloc = false)
{
	int i;
	FILE* hFile;

	if (DebugOutput) {printf("Opening File (%s)\t", FileName);}
	hFile = fopen(FileName, "r");
	if (hFile == 0)
	{
		printf("FAILED\n");
		return(1);
	}

	fseek(hFile, 0, SEEK_END);
	buffersize = ftell(hFile);
	buffer = (char*) mallocl(buffersize + 1, "SourceInit-buffer");
	fseek(hFile, 0, SEEK_SET);

	if (DebugOutput) {printf("OK\nReading List\t\t\t");}
	ProcessLine(hFile, ProcessFunction, NULL, true);
	*SourceCount = CountSetLines(hFile);
	if (DebugOutput) {printf("%d\n", *SourceCount);}

	if (!NoAlloc)
	{
		SetNewIdent("SourceInit-Source");
		*Source = new T[*SourceCount + AddMem];
		if (*Source == 0)
		{
			printf("Memmory Allocation Error...\n");
			fclose(hFile);
			freel(buffer);
			return(1);
		}
	}
	if (DebugOutput) {printf("\t( ");}

	for (i = 0;i < *SourceCount;i++)
	{
		ProcessLine(hFile, ProcessFunction, (Source == NULL ? NULL : &((*Source)[i])), false);
		if (DebugOutput && Source) {printf("%s ", (*Source)[i].Name.buffer);}
	}
	if (DebugOutput) {printf(")\n");}
	if (DebugOutput) {printf("\n");}

	fclose(hFile);

	freel(buffer);

	return(0);
}

int FillArrayFromFile(char* FileName, int* Target, int MinLen)
{
	FILE* fp;
	int i = 0, j;
	char* buffer;
	int buffersize;
	int temp;

	fp = fopen(FileName, "r");

	fseek(fp, 0, SEEK_END);
	buffersize = ftell(fp);
	buffer = (char*)  mallocl(buffersize + 1, "FillArrayFromBFile-buffer");
	fseek(fp, 0, SEEK_SET);

	while (!feof(fp))
	{
		fgets(buffer, buffersize, fp);
		sscanf(buffer, "%d\t%d\n", &temp, &Target[i]);
		i++;
	}
	for (j = i;j < MinLen;j++)
	{
		Target[j] = Target[i - 1];
	}

	freel(buffer);

	return(0);
}
